/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2010
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */

#ifndef YAYI_COMMON_TIME_HPP__
#define YAYI_COMMON_TIME_HPP__

/*!@file
 * This file contains functions relative to time measurements (mainly for benchmarking purposes)
 *
 * @author Raffi Enficiaud
 */

#include <boost/date_time/posix_time/posix_time.hpp>

namespace yayi
{
  namespace time
  {
  
    struct s_time_elapsed
    {
      boost::posix_time::ptime time;
      
      s_time_elapsed() : time(boost::posix_time::microsec_clock::local_time()) {}
      s_time_elapsed(const s_time_elapsed& r_) : time(r_.time) {}
      
      double total_microseconds() const 
      {
        //int count = number_of_tenths*(time_duration::ticks_per_second()/10);

        return (boost::posix_time::microsec_clock::local_time() - time).total_microseconds();
        //return ((boost::posix_time::microsec_clock::local_time() - time).ticks() / boost::posix_time::time_duration::ticks_per_second());
      }
    };
  
  
  }
}

#endif /* YAYI_COMMON_TIME_HPP__ */
