/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2010
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */

#ifndef YAYI_PIXEL_IMAGE_COPY_T_HPP__
#define YAYI_PIXEL_IMAGE_COPY_T_HPP__



#include <algorithm>
#include <boost/call_traits.hpp>
#include <Yayi/core/yayiImageCore/include/ApplyToImage_unary_t.hpp>

namespace yayi
{

  template <class pixel_in, class pixel_out>
    struct s_copy : public std::unary_function<pixel_in, pixel_out>
  {
    pixel_out operator()(typename boost::call_traits<pixel_in>::param_type p) const throw()
    {
      return static_cast<pixel_out>(p);
    }
  };

  template <class pixel_in>
    struct s_copy<pixel_in, pixel_in> : public std::unary_function<pixel_in, pixel_in>
  {
    const pixel_in& operator()(const pixel_in& p) const throw()
    {
      return p;
    }
  };
  
  // Use boost::has_trivial_assign for memcpy. 

  template <class image_in_, class image_out_>
    yaRC copy_image_t(const image_in_& imin, image_out_& imo)
  {
    typedef s_copy<
      typename image_in_::pixel_type, 
      typename image_out_::pixel_type>  operator_type;
    
    s_apply_unary_operator op_processor;
    
    operator_type op;
    return op_processor(imin, imo, op);    
  }

}

#endif

