/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2010
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */


#include <Yayi/core/yayiPixelProcessing/image_arithmetics.hpp>
#include <Yayi/core/yayiPixelProcessing/include/image_arithmetics_t.hpp>

#include <Yayi/core/yayiImageCore/include/yayiImageCore_Impl.hpp>
#include <Yayi/core/yayiCommon/include/common_dispatch.hpp>
#include <Yayi/core/yayiImageCore/include/yayiImageCore_ImplDispatch.hpp>
#include <Yayi/core/yayiCommon/include/common_variantDispatch.hpp>


namespace yayi
{

  yaRC image_multiply_constant(const IImage* imin, variant c, IImage* imout)
  {
    yaRC return_value;

    yayi::dispatcher::s_dispatcher<
      yaRC, 
      const IImage*, 
      variant, 
      IImage*> dispatch_object(return_value, imin, c, imout);

    yaRC res = dispatch_object.calls_first_suitable(
      fusion::vector_tie(
        multiply_images_constant_t< Image<yaUINT8>,     yaINT32,  Image<yaUINT8> >,
        multiply_images_constant_t< Image<yaF_simple>,  yaUINT8,  Image<yaUINT8> >,
        multiply_images_constant_t< Image<yaF_double>,  yaUINT8,  Image<yaUINT8> >,
        multiply_images_constant_t< Image<yaF_simple>,  yaF_simple, Image<yaF_simple> >,
        multiply_images_constant_t< Image<yaF_double>,  yaF_double, Image<yaF_double> >,
        multiply_images_constant_t< Image<yaUINT8>,     yaINT32,  Image<yaUINT16> >
      )
      );
      
    if(res == yaRC_ok)
      return return_value;
    return res;  
  }

}
