#!/usr/bin/env python2.3
#
#  -:- LICENCE -:- 
# Copyright Raffi Enficiaud 2007-2010
# 
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file ../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
# 
#  -:- LICENCE -:- 
#


import os, sys, unittest, exceptions

if(globals().has_key('__file__')):
  sys.path.insert(0, os.path.join(os.path.split(__file__)[0], os.path.pardir, "yayiCommonPython"))
from common_test import *
import YayiIOPython               as yaIO
import YayiImageCorePython        as yaCORE
import YayiPixelProcessingPython  as yaP



class ImageIOCase(unittest.TestCase):
  def setUp(self):
    self.image = yaCORE.ImageFactory(YAC.type(YAC.c_scalar, YAC.s_ui8), 2)

  def tearDown(self):
    del self.image
    
  def testJPGIO(self):
    im = yaIO.readJPG(os.path.join(os.path.split(__file__)[0], os.pardir, os.pardir, "coreTests", "yayiTestData", "release-grosse bouche.jpg"))
    print im  
    self.assert_(im.Size == (450,600), 'error on the size of the read image : ' + str(im.Size) + ' (read) != ' + str((450,600)))
    outfile = os.tmpnam() + "release-grosse bouche.jpg"
    yaIO.writeJPG(outfile, im)
    os.remove(outfile) 
  
  def testHDF5IO(self):
    im = yaIO.readHDF5(os.path.join(os.path.split(__file__)[0], os.pardir, os.pardir, "coreTests", "yayiTestData", "debug_HDF5.h5"), "bla")
    #im = yaIO.readHDF5(os.path.join(os.path.split(__file__)[0], os.pardir, os.pardir, "coreTests", "yayiTestData", "wt_K_4ora_colchcine60_RAM2.h5"), "/rawdata/stitched_weighted_ch0/")
    #im = yaIO.readHDF5("/home/enficiau/wt_K_4ora_colchcine60_RAM2.h5")
    print "Reading of the HDF5 image ok !! : "
    print im

    print im.Size
    print im.pixel((0,0,0)).value
    print im.pixel((5,4,2)).value
    self.assert_(im.pixel((5,4,2)).value == 5*4*2);

    for z in range(10):
      for y in range(10):
        for x in range(10):
          self.assert_(im.pixel((x,y,z)).value == x*y*z);

    print "test end"



def suite():
  suite = unittest.TestSuite()
  
  suite.addTest(ImageIOCase('testJPGIO'))
  if(sys.argv.count('HDF5')):
    suite.addTest(ImageIOCase('testHDF5IO'))
  return suite


if __name__ == '__main__':
  ret = unittest.TextTestRunner(verbosity=3).run(suite())
  if(not ret.wasSuccessful()):
    sys.exit(-1)


