/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2010
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */

#include <Yayi/python/yayiPixelProcessingPython/include/pixelprocessing_python.hpp>

#include <Yayi/core/yayiPixelProcessing/image_compare.hpp>

using namespace bpy;

void declare_compare() {

  bpy::enum_<yayi::comparison_operations>("comparison_operations")
    .value("op_equal", yayi::e_co_equal)
    .value("op_diff",  yayi::e_co_different)
    .value("op_supeq", yayi::e_co_superior)
    .value("op_sup",   yayi::e_co_superior_strict)
    .value("op_infeq", yayi::e_co_inferior)
    .value("op_inf",   yayi::e_co_inferior_strict)

    //.export_values()
    ;
    

  def("CompareS",  &yayi::image_compare_s, 
  "(im_source, compare_op, value, value_true, value_false, im_destination) : "
  "Compare an image to value at a pixel level, fills the destination image with value_true or value_false accordingly");

  def("CompareI",  &yayi::image_compare_i, 
  "(im_source1, compare_op, im_source2, value_true, value_false, im_destination) : "
  "Compare an im_source1 to im_source2 at a pixel level, fills the destination image with value_true or value_false accordingly");

    
}
